package ovh.gasser.newshapes;

import ovh.gasser.newshapes.attributes.SelectionAttributes;
import ovh.gasser.newshapes.shapes.Shape;
import ovh.gasser.newshapes.util.Streamable;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class Selection implements Streamable<Shape> {
    private final List<Shape> selectedShapes = new ArrayList<>();

    @Override
    public Iterator<Shape> iterator() {
        return selectedShapes.iterator();
    }

    public void clear() {
        for (Shape shape : selectedShapes) {
            shape.addAttributes(new SelectionAttributes(false));
        }

        selectedShapes.clear();
    }

    public void add(Shape s) {
        selectedShapes.add(s);
        s.addAttributes(new SelectionAttributes(true));
    }
}
